Attribute VB_Name = "modConvertData"
Option Explicit

Public Sub MakeTable(ByRef rtb As RichTextBox, ByVal Data As Variant, _
                     ByVal tbl As Table)

    Dim col As Long
    Dim row As Long
    Dim index As Long
    Dim xAxisText As Integer
    Dim yAxisText As Integer
    Dim TableSize As Integer
    Dim TableStart As Integer
    Dim ScaleFactor As Double
    Dim Offset As Double
    Dim fmt As String

    ' Each table has to be extracted from the array
    ' Extracting the y and x axis text requires different
    ' references to the table
    ' The size, location of x and y scales are contained
    ' in the array TableIndex()

    On Error GoTo TableError

    fmt = TableIndex(tbl, TBL_FMT)
    yAxisText = TableIndex(tbl, TBL_Y_AXIS)
    xAxisText = TableIndex(tbl, TBL_X_AXIS)
    TableSize = TableIndex(tbl, TBL_SIZE)
    TableStart = TableIndex(tbl, TBL_START)
    ScaleFactor = TableIndex(tbl, TBL_SCALE)
    Offset = TableIndex(tbl, TBL_OFFSET)

    rtb.SelText = vbCrLf & vbCrLf
    rtb.SelText = TableIndex(tbl, TBL_NAME) & vbCrLf
    For row = 1 To TableSize
        ' print the Y-axis value
        index = yAxisText + TableSize - row
        rtb.SelText = Format(Data(index), " ##0 -")
        For col = 1 To TableSize
            ' Print the row of table values
            index = col + (TableSize - row) * TableSize - 1
            index = index + TableStart
            rtb.SelText = Format((Data(index) + Offset) * ScaleFactor, fmt)
        Next col
        rtb.SelText = vbCrLf
    Next row

    ' write the rpm
    rtb.SelText = vbCrLf & "    "
    For col = 1 To TableSize
        index = xAxisText + col - 1
        rtb.SelText = Format(Data(index), "   ##")
    Next col
    rtb.SelText = vbCrLf

    Exit Sub
TableError:
    Debug.Print "Error: "; Err.Description


End Sub
