Attribute VB_Name = "modGlobal"
Option Explicit

Global TableIndex(10, 8) As Variant
Global VariableIndex() As String

' TABLES
' Define an array that will give us the table information
' to get the table and create a table output
' first index = table name
' second index 0 - Data format string
'              1 - Page
'              2     Start of y-axis
'              3     Start of x-axis
'              4     Row/column length
'              5     Scale factor
'              6     Offset
'              7     index for start of table
'              8     Table name (text)

' The different types of tables
Public Enum Table
    VE1 = 0
    VE2 = 1
    VE3 = 2
    AFR1 = 3
    AFR2 = 4
    IGN1 = 5
End Enum

Global Const TBL_FMT = 0
Global Const TBL_PAGE = 1
Global Const TBL_Y_AXIS = 2
Global Const TBL_X_AXIS = 3
Global Const TBL_SIZE = 4
Global Const TBL_SCALE = 5
Global Const TBL_OFFSET = 6
Global Const TBL_START = 7
Global Const TBL_NAME = 8

Public Sub setTable()
' VE 1 veBins1
    TableIndex(Table.VE1, TBL_FMT) = "  ###"
    TableIndex(Table.VE1, TBL_PAGE) = 1         ' page 1
    TableIndex(Table.VE1, TBL_Y_AXIS) = 170
    TableIndex(Table.VE1, TBL_X_AXIS) = 158
    TableIndex(Table.VE1, TBL_SIZE) = 12
    TableIndex(Table.VE1, TBL_SCALE) = 1
    TableIndex(Table.VE1, TBL_OFFSET) = 0
    TableIndex(Table.VE1, TBL_NAME) = "VE Table 1 (veBins1)"

    ' VE 2 veBins2 NOT TESTED
    TableIndex(Table.VE2, TBL_FMT) = "  ###"
    TableIndex(Table.VE2, TBL_PAGE) = 2         ' page 2
    TableIndex(Table.VE2, TBL_Y_AXIS) = 170
    TableIndex(Table.VE2, TBL_X_AXIS) = 158
    TableIndex(Table.VE2, TBL_SIZE) = 12
    TableIndex(Table.VE2, TBL_SCALE) = 1
    TableIndex(Table.VE2, TBL_OFFSET) = 0
    TableIndex(Table.VE2, TBL_NAME) = "VE Table 2"

    ' VE 3 veBins3
    TableIndex(Table.VE3, TBL_FMT) = "  ###"
    TableIndex(Table.VE3, TBL_PAGE) = 5         ' page 6
    TableIndex(Table.VE3, TBL_Y_AXIS) = 156
    TableIndex(Table.VE3, TBL_X_AXIS) = 144
    TableIndex(Table.VE3, TBL_SIZE) = 12
    TableIndex(Table.VE3, TBL_SCALE) = 1
    TableIndex(Table.VE3, TBL_OFFSET) = 0
    TableIndex(Table.VE3, TBL_NAME) = "VE Table 3 (veBins3)"

    ' These AFR tables have a constant and offset
    ' for AFR = 14.7 when used with 0-5V = 10 - 12 AFR
    ' See msns-extra.ini for other constants and offsets
    ' AFR 1 afrBins1
    TableIndex(Table.AFR1, TBL_FMT) = " ##.0"
    TableIndex(Table.AFR1, TBL_START) = 0
    TableIndex(Table.AFR1, TBL_PAGE) = 6        'page 7
    TableIndex(Table.AFR1, TBL_Y_AXIS) = 72
    TableIndex(Table.AFR1, TBL_X_AXIS) = 64
    TableIndex(Table.AFR1, TBL_SIZE) = 8
    TableIndex(Table.AFR1, TBL_SCALE) = 0.0392    '10 / 255
    TableIndex(Table.AFR1, TBL_OFFSET) = 255
    TableIndex(Table.AFR1, TBL_NAME) = "AFR Table 1 (afrBins1)"

    ' AFR 2 afrBins2 (for VE 3)
    TableIndex(Table.AFR2, TBL_FMT) = " ##.0"
    TableIndex(Table.AFR2, TBL_START) = 80
    TableIndex(Table.AFR2, TBL_PAGE) = 6        'page 7
    TableIndex(Table.AFR2, TBL_Y_AXIS) = 144
    TableIndex(Table.AFR2, TBL_X_AXIS) = 152
    TableIndex(Table.AFR2, TBL_SIZE) = 8
    TableIndex(Table.AFR2, TBL_SCALE) = 0.0392    '10 / 255
    TableIndex(Table.AFR2, TBL_OFFSET) = 255
    TableIndex(Table.AFR2, TBL_NAME) = "AFR Table 2 for VE table 3 (afrBins1)"


    ' IGN 1 advTable1
    TableIndex(Table.IGN1, TBL_FMT) = "   ##"
    TableIndex(Table.IGN1, TBL_START) = 0
    TableIndex(Table.IGN1, TBL_PAGE) = 3        'page 3
    TableIndex(Table.IGN1, TBL_Y_AXIS) = 156
    TableIndex(Table.IGN1, TBL_X_AXIS) = 144
    TableIndex(Table.IGN1, TBL_SIZE) = 12
    TableIndex(Table.IGN1, TBL_SCALE) = 0.352
    TableIndex(Table.IGN1, TBL_OFFSET) = -28.4
    TableIndex(Table.IGN1, TBL_NAME) = "IGN Table (advTable1)"


End Sub

' Variables
' Sets up a list of indexes to retrieve the Real Time Variables
' from the array returned with the 'A' command
' Note, not all of these are implemented in the examples


Public Sub setVariable()
    Dim tmpString As String

    'Var Name  data   type      units   Factor  Offset
    tmpString = _
    "secl," & _
    "squirt," & _
    "engine," & _
    "baroADC," & _
                "mapADC," & _
                "matADC," & _
                "cltADC," & _
                "tpsADC," & _
                "batADC," & _
                "egoADC," & _
                "egoCorrection," & _
                "airCorrection," & _
                "warmupEnrich," & _
                "rpm100," & _
                "pulseWidth1," & _
                "accelEnrich," & _
                "baroCorrection," & _
                "gammaEnrich," & _
                "veCurr1," & _
                "pulseWidth2," & _
                "veCurr2," & _
                "idleDC"
    VariableIndex = Split(tmpString, ",")
End Sub
